Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.imageio.stream
Class ImageOutputStreamImpl

    java.lang.Object
      javax.imageio.stream.ImageInputStreamImpl
          javax.imageio.stream.ImageOutputStreamImpl

All Implemented Interfaces:
  DataInput, DataOutput, ImageInputStream, ImageOutputStream

Direct Known Subclasses:
  FileCacheImageOutputStream, FileImageOutputStream, MemoryCacheImageOutputStream

    public abstract class ImageOutputStreamImpl

extends ImageInputStreamImpl
implements ImageOutputStream

An abstract class implementing the `ImageOutputStream` interface. This class is designed to reduce the number of methods that must be implemented by subclasses.

Field Summary

Fields inherited from class javax.imageio.stream.ImageInputStreamImpl
`bitOffset, byteOrder, flushedPos, streamPos`

Constructor Summary
`ImageOutputStreamImpl()` Constructs an `ImageOutputStreamImpl`.

Method Summary
`protected void` | `flushBits()` If the bit offset is non-zero, forces the remaining bits in the current byte to 0 and advances the stream position by one.
`void` | `write(byte[] b)` Writes to the output stream all the bytes in array `b`.
`abstract void` | `write(byte[] b, int off, int len)` Writes `len` bytes from array `b`, in order, to the output stream.
`abstract void` | `write(int b)` Writes to the output stream the eight low-order bits of the argument `b`.
`void` | `writeBit(int bit)` Writes a single bit, given by the least significant bit of the argument, to the stream at the current bit offset within the current byte position.
`void` | `writeBits(long bits, int numBits)` Writes a sequence of bits, given by the `numBits` least significant bits of the `bits` argument in left-to-right order, to the stream at the current bit offset within the current byte position.
`void` | `writeBoolean(boolean v)` Writes a `boolean` value to this output stream.
`void` | `writeByte(int v)` Writes to the output stream the eight low- order bits of the argument `v`.
`void` | `writeBytes(String s)` Writes a string to the output stream.
`void` | `writeChar(int v)` Writes a `char` value, which is comprised of two bytes, to the output stream.
`void` | `writeChars(char[] c, int off, int len)` Writes a sequence of chars to the stream at the current position.
`void` | `writeChars(String s)` Writes every character in the string `s`, to the output stream, in order, two bytes per character.
`void` | `writeDouble(double v)` Writes a `double` value, which is comprised of eight bytes, to the output stream.
`void` | `writeDoubles(double[] d, int off, int len)` Writes a sequence of doubles to the stream at the current position.
`void` | `writeFloat(float v)` Writes a `float` value, which is comprised of four bytes, to the output stream.
`void` | `writeFloats(float[] f, int off, int len)` Writes a sequence of floats to the stream at the current position.
`void` | `writeInt(int v)` Writes an `int` value, which is comprised of four bytes, to the output stream.
`void` | `writeInts(int[] i, int off, int len)` Writes a sequence of ints to the stream at the current position.
`void` | `writeLong(long v)` Writes a `long` value, which is comprised of eight bytes, to the output stream.
`void` | `writeLongs(long[] l, int off, int len)` Writes a sequence of longs to the stream at the current position.
`void` | `writeShort(int v)` Writes two bytes to the output stream to represent the value of the argument.
`void` | `writeShorts(short[] s, int off, int len)` Writes a sequence of shorts to the stream at the current position.
`void` | `writeUTF(String s)` Writes two bytes of length information to the output stream, followed by the modified UTF-8 representation of every character in the string `s`.

Methods inherited from class javax.imageio.stream.ImageInputStreamImpl
`checkClosed, close, finalize, flush, flushBefore, getBitOffset, getByteOrder, getFlushedPosition, getStreamPosition, isCached, isCachedFile, isCachedMemory, length, mark, read, read, read, readBit, readBits, readBoolean, readByte, readBytes, readChar, readDouble, readFloat, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readInt, readLine, readLong, readShort, readUnsignedByte, readUnsignedInt, readUnsignedShort, readUTF, reset, seek, setBitOffset, setByteOrder, skipBytes, skipBytes`

Methods inherited from class java.lang.Object
`clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.imageio.stream.ImageOutputStream
`flushBefore`

Methods inherited from interface javax.imageio.stream.ImageInputStream
`close, flush, getBitOffset, getByteOrder, getFlushedPosition, getStreamPosition, isCached, isCachedFile, isCachedMemory, length, mark, read, read, read, readBit, readBits, readBoolean, readByte, readBytes, readChar, readDouble, readFloat, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readFully, readInt, readLine, readLong, readShort, readUnsignedByte, readUnsignedInt, readUnsignedShort, readUTF, reset, seek, setBitOffset, setByteOrder, skipBytes, skipBytes`

Constructor Detail

### ImageOutputStreamImpl

    public ImageOutputStreamImpl()

  Constructs an `ImageOutputStreamImpl`.

Method Detail

### write

    public abstract void write(int b)
                        throws IOException

  Description copied from interface: `DataOutput`
  Writes to the output stream the eight low-order bits of the argument `b`. The 24 high-order bits of `b` are ignored.

  Specified by:
    `write` in interface `DataOutput`
  Specified by:
    `write` in interface `ImageOutputStream`
  Parameters:
    `b` - the byte to be written.
  Throws:
    `IOException` - if an I/O error occurs.

### write

    public void write(byte[] b)
               throws IOException

  Description copied from interface: `DataOutput`
  Writes to the output stream all the bytes in array `b`. If `b` is `null`, a `NullPointerException` is thrown. If `b.length` is zero, then no bytes are written. Otherwise, the byte `b[0]` is written first, then `b[1]`, and so on; the last byte written is `b[b.length-1]`.

  Specified by:
    `write` in interface `DataOutput`
  Specified by:
    `write` in interface `ImageOutputStream`
  Parameters:
    `b` - the data.
  Throws:
    `IOException` - if an I/O error occurs.

### write

    public abstract void write(byte[] b,
                               int off,
                               int len)
                        throws IOException

  Description copied from interface: `DataOutput`
  Writes `len` bytes from array `b`, in order, to the output stream. If `b` is `null`, a `NullPointerException` is thrown. If `off` is negative, or `len` is negative, or `off+len` is greater than the length of the array `b`, then an `IndexOutOfBoundsException` is thrown. If `len` is zero, then no bytes are written. Otherwise, the byte `b[off]` is written first, then `b[off+1]`, and so on; the last byte written is `b[off+len-1]`.

  Specified by:
    `write` in interface `DataOutput`
  Specified by:
    `write` in interface `ImageOutputStream`
  Parameters:
    `b` - the data.
    `off` - the start offset in the data.
    `len` - the number of bytes to write.
  Throws:
    `IOException` - if an I/O error occurs.

### writeBoolean

    public void writeBoolean(boolean v)
                      throws IOException

  Description copied from interface: `DataOutput`
  Writes a `boolean` value to this output stream. If the argument `v` is `true`, the value `(byte)1` is written; if `v` is `false`, the value `(byte)0` is written. The byte written by this method may be read by the `readBoolean` method of interface `DataInput`, which will then return a `boolean` equal to `v`.

  Specified by:
    `writeBoolean` in interface `DataOutput`
  Specified by:
    `writeBoolean` in interface `ImageOutputStream`
  Parameters:
    `v` - the boolean to be written.
  Throws:
    `IOException` - if an I/O error occurs.

### writeByte

    public void writeByte(int v)
                   throws IOException

  Description copied from interface: `DataOutput`
  Writes to the output stream the eight low- order bits of the argument `v`. The 24 high-order bits of `v` are ignored. (This means that `writeByte` does exactly the same thing as `write` for an integer argument.) The byte written by this method may be read by the `readByte` method of interface `DataInput`, which will then return a `byte` equal to `(byte)v`.

  Specified by:
    `writeByte` in interface `DataOutput`
  Specified by:
    `writeByte` in interface `ImageOutputStream`
  Parameters:
    `v` - the byte value to be written.
  Throws:
    `IOException` - if an I/O error occurs.

### writeShort

    public void writeShort(int v)
                    throws IOException

  Description copied from interface: `DataOutput`
  Writes two bytes to the output stream to represent the value of the argument. The byte values to be written, in the order shown, are:

       (byte)(0xff & (v >> 8))
       (byte)(0xff & v)

  The bytes written by this method may be read by the `readShort` method of interface `DataInput` , which will then return a `short` equal to `(short)v`.

  Specified by:
    `writeShort` in interface `DataOutput`
  Specified by:
    `writeShort` in interface `ImageOutputStream`
  Parameters:
    `v` - the `short` value to be written.
  Throws:
    `IOException` - if an I/O error occurs.

### writeChar

    public void writeChar(int v)
                   throws IOException

  Description copied from interface: `DataOutput`
  Writes a `char` value, which is comprised of two bytes, to the output stream. The byte values to be written, in the order shown, are:

       (byte)(0xff & (v >> 8))
       (byte)(0xff & v)

  The bytes written by this method may be read by the `readChar` method of interface `DataInput` , which will then return a `char` equal to `(char)v`.

  Specified by:
    `writeChar` in interface `DataOutput`
  Specified by:
    `writeChar` in interface `ImageOutputStream`
  Parameters:
    `v` - the `char` value to be written.
  Throws:
    `IOException` - if an I/O error occurs.
  See Also:
    `ImageOutputStream.writeShort(int)`

### writeInt

    public void writeInt(int v)
                  throws IOException

  Description copied from interface: `DataOutput`
  Writes an `int` value, which is comprised of four bytes, to the output stream. The byte values to be written, in the order shown, are:

       (byte)(0xff & (v >> 24))
       (byte)(0xff & (v >> 16))
       (byte)(0xff & (v >>    8))
       (byte)(0xff & v)

  The bytes written by this method may be read by the `readInt` method of interface `DataInput` , which will then return an `int` equal to `v`.

  Specified by:
    `writeInt` in interface `DataOutput`
  Specified by:
    `writeInt` in interface `ImageOutputStream`
  Parameters:
    `v` - the `int` value to be written.
  Throws:
    `IOException` - if an I/O error occurs.

### writeLong

    public void writeLong(long v)
                   throws IOException

  Description copied from interface: `DataOutput`
  Writes a `long` value, which is comprised of eight bytes, to the output stream. The byte values to be written, in the order shown, are:

       (byte)(0xff & (v >> 56))
       (byte)(0xff & (v >> 48))
       (byte)(0xff & (v >> 40))
       (byte)(0xff & (v >> 32))
       (byte)(0xff & (v >> 24))
       (byte)(0xff & (v >> 16))
       (byte)(0xff & (v >>  8))
       (byte)(0xff & v)

  The bytes written by this method may be read by the `readLong` method of interface `DataInput` , which will then return a `long` equal to `v`.

  Specified by:
    `writeLong` in interface `DataOutput`
  Specified by:
    `writeLong` in interface `ImageOutputStream`
  Parameters:
    `v` - the `long` value to be written.
  Throws:
    `IOException` - if an I/O error occurs.

### writeFloat

    public void writeFloat(float v)
                    throws IOException

  Description copied from interface: `DataOutput`
  Writes a `float` value, which is comprised of four bytes, to the output stream. It does this as if it first converts this `float` value to an `int` in exactly the manner of the `Float.floatToIntBits` method and then writes the `int` value in exactly the manner of the `writeInt` method. The bytes written by this method may be read by the `readFloat` method of interface `DataInput`, which will then return a `float` equal to `v`.

  Specified by:
    `writeFloat` in interface `DataOutput`
  Specified by:
    `writeFloat` in interface `ImageOutputStream`
  Parameters:
    `v` - the `float` value to be written.
  Throws:
    `IOException` - if an I/O error occurs.

### writeDouble

    public void writeDouble(double v)
                     throws IOException

  Description copied from interface: `DataOutput`
  Writes a `double` value, which is comprised of eight bytes, to the output stream. It does this as if it first converts this `double` value to a `long` in exactly the manner of the `Double.doubleToLongBits` method and then writes the `long` value in exactly the manner of the `writeLong` method. The bytes written by this method may be read by the `readDouble` method of interface `DataInput`, which will then return a `double` equal to `v`.

  Specified by:
    `writeDouble` in interface `DataOutput`
  Specified by:
    `writeDouble` in interface `ImageOutputStream`
  Parameters:
    `v` - the `double` value to be written.
  Throws:
    `IOException` - if an I/O error occurs.

### writeBytes

    public void writeBytes(String s)
                    throws IOException

  Description copied from interface: `DataOutput`
  Writes a string to the output stream. For every character in the string `s`, taken in order, one byte is written to the output stream. If `s` is `null`, a `NullPointerException` is thrown.

  If `s.length` is zero, then no bytes are written. Otherwise, the character `s[0]` is written first, then `s[1]`, and so on; the last character written is `s[s.length-1]`. For each character, one byte is written, the low-order byte, in exactly the manner of the `writeByte` method . The high-order eight bits of each character in the string are ignored.

  Specified by:
    `writeBytes` in interface `DataOutput`
  Specified by:
    `writeBytes` in interface `ImageOutputStream`
  Parameters:
    `s` - the string of bytes to be written.
  Throws:
    `IOException` - if an I/O error occurs.

### writeChars

    public void writeChars(String s)
                    throws IOException

  Description copied from interface: `DataOutput`
  Writes every character in the string `s`, to the output stream, in order, two bytes per character. If `s` is `null`, a `NullPointerException` is thrown. If `s.length` is zero, then no characters are written. Otherwise, the character `s[0]` is written first, then `s[1]`, and so on; the last character written is `s[s.length-1]`. For each character, two bytes are actually written, high-order byte first, in exactly the manner of the `writeChar` method.

  Specified by:
    `writeChars` in interface `DataOutput`
  Specified by:
    `writeChars` in interface `ImageOutputStream`
  Parameters:
    `s` - the string value to be written.
  Throws:
    `IOException` - if an I/O error occurs.

### writeUTF

    public void writeUTF(String s)
                  throws IOException

  Description copied from interface: `DataOutput`
  Writes two bytes of length information to the output stream, followed by the modified UTF-8 representation of every character in the string `s`. If `s` is `null`, a `NullPointerException` is thrown. Each character in the string `s` is converted to a group of one, two, or three bytes, depending on the value of the character.

  If a character `c` is in the range `\u0001` through `\u007f`, it is represented by one byte:

      (byte)c

  If a character `c` is `\u0000` or is in the range `\u0080` through `\u07ff`, then it is represented by two bytes, to be written in the order shown:

       (byte)(0xc0 | (0x1f & (c >> 6)))
       (byte)(0x80 | (0x3f & c))

  If a character `c` is in the range `\u0800` through `uffff`, then it is represented by three bytes, to be written in the order shown:

       (byte)(0xe0 | (0x0f & (c >> 12)))
       (byte)(0x80 | (0x3f & (c >>  6)))
       (byte)(0x80 | (0x3f & c))

  First, the total number of bytes needed to represent all the characters of `s` is calculated. If this number is larger than `65535`, then a `UTFDataFormatException` is thrown. Otherwise, this length is written to the output stream in exactly the manner of the `writeShort` method; after this, the one-, two-, or three-byte representation of each character in the string `s` is written.

  The bytes written by this method may be read by the `readUTF` method of interface `DataInput` , which will then return a `String` equal to `s`.

  Specified by:
    `writeUTF` in interface `DataOutput`
  Specified by:
    `writeUTF` in interface `ImageOutputStream`
  Parameters:
    `s` - the string value to be written.
  Throws:
    `IOException` - if an I/O error occurs.

### writeShorts

    public void writeShorts(short[] s,
                            int off,
                            int len)
                     throws IOException

  Description copied from interface: `ImageOutputStream`
  Writes a sequence of shorts to the stream at the current position. If `len` is 0, nothing is written. The short `s[off]` is written first, then the short `s[off + 1]`, and so on. The byte order of the stream is used to determine the order in which the individual bytes are written.

  If the bit offset within the stream is non-zero, the remainder of the current byte is padded with 0s and written out first. The bit offset will be 0 after the write.

  Specified by:
    `writeShorts` in interface `ImageOutputStream`
  Parameters:
    `s` - an array of `short`s to be written.
    `off` - the start offset in the data.
    `len` - the number of `short`s to write.
  Throws:
    `IOException` - if an I/O error occurs.

### writeChars

    public void writeChars(char[] c,
                           int off,
                           int len)
                    throws IOException

  Description copied from interface: `ImageOutputStream`
  Writes a sequence of chars to the stream at the current position. If `len` is 0, nothing is written. The char `c[off]` is written first, then the char `c[off + 1]`, and so on. The byte order of the stream is used to determine the order in which the individual bytes are written.

  If the bit offset within the stream is non-zero, the remainder of the current byte is padded with 0s and written out first. The bit offset will be 0 after the write.

  Specified by:
    `writeChars` in interface `ImageOutputStream`
  Parameters:
    `c` - an array of `char`s to be written.
    `off` - the start offset in the data.
    `len` - the number of `char`s to write.
  Throws:
    `IOException` - if an I/O error occurs.

### writeInts

    public void writeInts(int[] i,
                          int off,
                          int len)
                   throws IOException

  Description copied from interface: `ImageOutputStream`
  Writes a sequence of ints to the stream at the current position. If `len` is 0, nothing is written. The int `i[off]` is written first, then the int `i[off + 1]`, and so on. The byte order of the stream is used to determine the order in which the individual bytes are written.

  If the bit offset within the stream is non-zero, the remainder of the current byte is padded with 0s and written out first. The bit offset will be 0 after the write.

  Specified by:
    `writeInts` in interface `ImageOutputStream`
  Parameters:
    `i` - an array of `int`s to be written.
    `off` - the start offset in the data.
    `len` - the number of `int`s to write.
  Throws:
    `IOException` - if an I/O error occurs.

### writeLongs

    public void writeLongs(long[] l,
                           int off,
                           int len)
                    throws IOException

  Description copied from interface: `ImageOutputStream`
  Writes a sequence of longs to the stream at the current position. If `len` is 0, nothing is written. The long `l[off]` is written first, then the long `l[off + 1]`, and so on. The byte order of the stream is used to determine the order in which the individual bytes are written.

  If the bit offset within the stream is non-zero, the remainder of the current byte is padded with 0s and written out first. The bit offset will be 0 after the write.

  Specified by:
    `writeLongs` in interface `ImageOutputStream`
  Parameters:
    `l` - an array of `long`s to be written.
    `off` - the start offset in the data.
    `len` - the number of `long`s to write.
  Throws:
    `IOException` - if an I/O error occurs.

### writeFloats

    public void writeFloats(float[] f,
                            int off,
                            int len)
                     throws IOException

  Description copied from interface: `ImageOutputStream`
  Writes a sequence of floats to the stream at the current position. If `len` is 0, nothing is written. The float `f[off]` is written first, then the float `f[off + 1]`, and so on. The byte order of the stream is used to determine the order in which the individual bytes are written.

  If the bit offset within the stream is non-zero, the remainder of the current byte is padded with 0s and written out first. The bit offset will be 0 after the write.

  Specified by:
    `writeFloats` in interface `ImageOutputStream`
  Parameters:
    `f` - an array of `float`s to be written.
    `off` - the start offset in the data.
    `len` - the number of `float`s to write.
  Throws:
    `IOException` - if an I/O error occurs.

### writeDoubles

    public void writeDoubles(double[] d,
                             int off,
                             int len)
                      throws IOException

  Description copied from interface: `ImageOutputStream`
  Writes a sequence of doubles to the stream at the current position. If `len` is 0, nothing is written. The double `d[off]` is written first, then the double `d[off + 1]`, and so on. The byte order of the stream is used to determine the order in which the individual bytes are written.

  If the bit offset within the stream is non-zero, the remainder of the current byte is padded with 0s and written out first. The bit offset will be 0 after the write.

  Specified by:
    `writeDoubles` in interface `ImageOutputStream`
  Parameters:
    `d` - an array of `doubles`s to be written.
    `off` - the start offset in the data.
    `len` - the number of `double`s to write.
  Throws:
    `IOException` - if an I/O error occurs.

### writeBit

    public void writeBit(int bit)
                  throws IOException

  Description copied from interface: `ImageOutputStream`
  Writes a single bit, given by the least significant bit of the argument, to the stream at the current bit offset within the current byte position. The upper 31 bits of the argument are ignored. The given bit replaces the previous bit at that position. The bit offset is advanced by one and reduced modulo 8.

  If any bits of a particular byte have never been set at the time the byte is flushed to the destination, those bits will be set to 0 automatically.

  Specified by:
    `writeBit` in interface `ImageOutputStream`
  Parameters:
    `bit` - an `int` whose least significant bit is to be written to the stream.
  Throws:
    `IOException` - if an I/O error occurs.

### writeBits

    public void writeBits(long bits,
                          int numBits)
                   throws IOException

  Description copied from interface: `ImageOutputStream`
  Writes a sequence of bits, given by the `numBits` least significant bits of the `bits` argument in left-to-right order, to the stream at the current bit offset within the current byte position. The upper `64 - numBits` bits of the argument are ignored. The bit offset is advanced by `numBits` and reduced modulo 8. Note that a bit offset of 0 always indicates the most-significant bit of the byte, and bytes of bits are written out in sequence as they are encountered. Thus bit writes are always effectively in network byte order. The actual stream byte order setting is ignored.

  Bit data may be accumulated in memory indefinitely, until `flushBefore` is called. At that time, all bit data prior to the flushed position will be written.

  If any bits of a particular byte have never been set at the time the byte is flushed to the destination, those bits will be set to 0 automatically.

  Specified by:
    `writeBits` in interface `ImageOutputStream`
  Parameters:
    `bits` - a `long` containing the bits to be written, starting with the bit in position `numBits - 1` down to the least significant bit.
    `numBits` - an `int` between 0 and 64, inclusive.
  Throws:
    `IOException` - if an I/O error occurs.

### flushBits

    protected final void flushBits()
                            throws IOException

  If the bit offset is non-zero, forces the remaining bits in the current byte to 0 and advances the stream position by one. This method should be called by subclasses at the beginning of the `write(int)` and `write(byte[], int, int)` methods.

  Throws:
    `IOException` - if an I/O error occurs.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Standard Ed. 5.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2004 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.